Mon Jan 25 01:38:54 CST 2010  pix@kepibu.org
  * Moar tests!
Mon Jan 25 01:38:27 CST 2010  pix@kepibu.org
  * Consider unexpected errors as test failures
  ...why is this not default behavior?
Fri Jan 22 18:31:24 CST 2010  pix@kepibu.org
  * Make tests file loadable
--- old-cl-unification/test/unification-tests.lisp	2010-01-26 21:21:20.000000000 -0600
+++ new-cl-unification/test/unification-tests.lisp	2010-01-26 21:21:20.000000000 -0600
@@ -1,12 +1,18 @@
 ;;;; -*- Mode: Lisp -*-
 
 ;;;; unification-tests.lisp --
-;;;; CL-UNIFICATION test suite.  Requires Franz's util.test package.
+;;;; CL-UNIFICATION test suite.  Requires Franz's util.test package on
+;;;; allegro or the ptester compatibility library on other lisps.
+#+allegro (require :tester)
+#-allegro (asdf:oos 'asdf:load-op :ptester)
 
 (cl:defpackage "UNIFY.TESTS"
-  (:use "CL" "UNIFY" "UTIL.TEST"))
+  (:use "CL" "UNIFY" #+allegro "UTIL.TEST" #-allegro "PTESTER"))
 (in-package "UNIFY.TESTS")
 
+;; nil seems like a lousy default for this
+(setf *error-protect-tests* t)
+
 (with-tests (:name "basic constant unification")
   (test t (unify:environment-p (unify 42 42)))
 
@@ -197,6 +203,8 @@
 		     (otherwise (error "error-inner")))))
    (otherwise (error "error-outer"))))
 
+(define-condition inner-error (unification-failure) ())
+
 (with-tests (:name "control flow")
   (test-error (nested-match-cases '(:a 42 :b 33)) :announce t)
 
@@ -204,6 +212,66 @@
 
   (test '(42 43 44) (nested-match-cases '(:a 42 :b ((:d 42) (:c 43) (:c 44))))
         :test #'equal)
+
+  (test-error (match ('(x) '(x) :errorp nil)
+                (error 'inner-error))
+              :condition-type 'inner-error
+              :known-failure t)
+
+  (test-error (matchf ((x) '(x) :errorp nil)
+                (error 'inner-error))
+              :condition-type 'inner-error
+              :known-failure t)
+
+  (with-tests (:name "final t-or-otherwise")
+    (test :success (matching ()
+                     (('x 'y) :fail)
+                     (t :success)))
+    (test :success (matching ()
+                     (('x 'y) :fail)
+                     (otherwise :success)))
+    (test :success (match-case ('x)
+                     ('y :fail)
+                     (t :success)))
+    (test :success (match-case ('x)
+                     ('y :fail)
+                     (otherwise :success)))
+    (test :success (matchf-case ('(x))
+                     ((y) :fail)
+                     (t :success)))
+    (test :success (matchf-case ('(x))
+                     ((y) :fail)
+                     (otherwise :success))))
+
+  (test-error (matching ()
+                        (('x 'y) :fail)
+                        (('x 'x) (error 'inner-error))
+                        (('?x 'x) x))
+              :condition-type 'inner-error)
+
+  (test-error (match-case ('(x))
+                          ('(y) :fail)
+                          ('(x) (error 'inner-error))
+                          ('(?x) x))
+              :condition-type 'inner-error
+              :known-failure t)
+
+  (test-error (matchf-case ('(x))
+                           ((y)  :fail)
+                           ((x)  (error 'inner-error))
+                           ((?x) x))
+              :condition-type 'inner-error
+              :known-failure t)
+
+  (test 'sym (match-case ('(sym))
+                          ('(a)  :fail)
+                          ('(b)  :fail)
+                          ('(?x) x)))
+
+  (test 'sym (matchf-case ('(sym))
+                          ((a)  :fail)
+                          ((b)  :fail)
+                          ((?x) x)))
   )
 
 

